VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmCreateMC 
   Caption         =   "Create Message & Category MC Files"
   ClientHeight    =   7935
   ClientLeft      =   2220
   ClientTop       =   2070
   ClientWidth     =   9135
   LinkTopic       =   "Form1"
   ScaleHeight     =   7935
   ScaleWidth      =   9135
   Begin VB.Frame Frame2 
      Caption         =   "Categories"
      Height          =   1335
      Left            =   2130
      TabIndex        =   6
      Top             =   6480
      Width           =   1935
      Begin VB.CommandButton cmdNewCatItem 
         Caption         =   "New I&tem"
         Height          =   435
         Left            =   180
         TabIndex        =   8
         Top             =   780
         Width           =   1605
      End
      Begin VB.CommandButton cmdNewCategory 
         Caption         =   "New &Category File"
         Height          =   435
         Left            =   180
         TabIndex        =   7
         Top             =   270
         Width           =   1605
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Messages"
      Height          =   1335
      Left            =   30
      TabIndex        =   3
      Top             =   6480
      Width           =   1935
      Begin VB.CommandButton cmdNewMsgItem 
         Caption         =   "New It&em"
         Height          =   435
         Left            =   180
         TabIndex        =   5
         Top             =   780
         Width           =   1605
      End
      Begin VB.CommandButton cmdNewMessage 
         Caption         =   "New &Message File"
         Height          =   435
         Left            =   180
         TabIndex        =   4
         Top             =   270
         Width           =   1605
      End
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   435
      Left            =   6270
      TabIndex        =   2
      Top             =   7380
      Width           =   1245
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   435
      Left            =   7860
      TabIndex        =   1
      Top             =   7380
      Width           =   1245
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   8370
      Top             =   150
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin RichTextLib.RichTextBox RichTextBox 
      Height          =   6405
      Left            =   0
      TabIndex        =   0
      Top             =   30
      Width           =   9105
      _ExtentX        =   16060
      _ExtentY        =   11298
      _Version        =   393217
      Enabled         =   -1  'True
      TextRTF         =   $"CreateMC.frx":0000
   End
End
Attribute VB_Name = "frmCreateMC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ************************************************************
' Copyright  1996-2001 Slightly Tilted Software
' All rights reserved
' You're absolutely free to use these resources within your
'     own applications, but you may not redistribute them
'     (as source) in any manner whatsoever, whether for profit
'     or not.
' The only legitimate source for the original source code is
'     at the VBPJ site and my own web site at:
'     http://www.SlightlyTiltedSoftware.com
' ************************************************************
Option Explicit

Private m_lngMsgNum                    As Long
Private m_blnTextChanged               As Boolean
Private m_strErrSeverity               As String

' --------------------------------------------
' Distinguish between Message and Category files
' --------------------------------------------
Private Enum enmTypeFile
   MsgFile = 1&
   CategoryFile = 2&
End Enum
Private m_enmFileType                  As enmTypeFile

' *******************************************************
' Routine Name : (PUBLIC in FORM) Property Let ErrorSeverity
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:56:57
' Inputs       : ByVal xi_strErrSeverity:String -
' Outputs      : N/A
' Description  : Public property -- called from frmErrSeverity
' Called By    : frmErrSeverity.cmdOK_Click
' *******************************************************
Public Property Let ErrorSeverity(ByVal xi_strErrSeverity As String)
   m_strErrSeverity = xi_strErrSeverity
End Property

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub RichTextBox_Change
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:57:47
' Inputs       : N/A
' Outputs      : N/A
' Description  : Any changes in the rich text box sets
'              :     the changed flag to TRUE
' Called By    : *****
' *******************************************************
Private Sub RichTextBox_Change()
   m_blnTextChanged = True
End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub cmdExit_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:11:41
' Inputs       : N/A
' Outputs      : N/A
' Description  : The default button -- unload this program
' Called By    : *****
' *******************************************************
Private Sub cmdExit_Click()
   Unload Me
End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub cmdSave_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:13:51
' Inputs       : N/A
' Outputs      : N/A
' Description  : Warn user if this file has already
'              :     been saved
' Called By    : *****
' *******************************************************
Private Sub cmdSave_Click()
   
   If m_blnTextChanged = False Then
      
      If MsgBox(Prompt:="Text has not changed -- Do you want to save it anyway?", _
                Buttons:=vbQuestion + vbYesNo + vbDefaultButton1, _
                Title:="Save File") = vbYes Then
         m_blnTextChanged = True
      
      Else
         Exit Sub
      
      End If
   
   End If
   
   ' ------------------------------------------
   ' Save the file(s)
   ' ------------------------------------------
   SaveFile
   
End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub cmdNewCategory_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:26:44
' Inputs       : N/A
' Outputs      : N/A
' Description  : Clear the textbox and add a header
'              :     for a new category file
' Called By    : *****
' *******************************************************
Private Sub cmdNewCategory_Click()
   Dim p_strRTF                        As String
   
   ' ------------------------------------------
   ' Check to see if current file needs to be saved
   ' ------------------------------------------
   CheckForSave
   
   ' ------------------------------------------
   ' Clear the text
   ' ------------------------------------------
   Me.RichTextBox.Text = vbNullString
   Me.RichTextBox.TextRTF = vbNullString
   
   ' ------------------------------------------
   ' Reset the numbering and the file type
   ' ------------------------------------------
   m_lngMsgNum = 1
   m_enmFileType = enmTypeFile.CategoryFile
   m_blnTextChanged = False
   
   Me.cmdNewMsgItem.Enabled = False
   Me.cmdNewCatItem.Enabled = True
   
   ' ------------------------------------------
   ' Set the initial RTF text
   ' ------------------------------------------
   p_strRTF = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fswiss\fprq2\fcharset0 Arial;}}" & vbCrLf & _
              "{\colortbl ;\red255\green0\blue0;\red0\green0\blue0;\red0\green0\blue255;}" & vbCrLf & _
              "\viewkind4\uc1\pard\cf1\b\f0\fs20 MessageIdTypedef=DWORD\par" & vbCrLf & _
              "\par" & vbCrLf & _
              "LanguageNames=(\par" & vbCrLf & _
              "  English=0x409:CAT00409\par" & vbCrLf & _
              "   )\par" & vbCrLf & _
              "\cf3\b0\f1\par" & vbCrLf & _
              "}"
 
   ' ------------------------------------------
   ' Add to RichTextBox, and set cursor at
   '     the end of the text
   ' ------------------------------------------
   Me.RichTextBox.TextRTF = p_strRTF
   Me.RichTextBox.SetFocus
   Me.RichTextBox.SelStart = Len(Me.RichTextBox.TextRTF)
   m_blnTextChanged = True

End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub cmdNewCatItem_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:28:49
' Inputs       : N/A
' Outputs      : N/A
' Description  : Add a new category item to the category
'              :     header
' Called By    : *****
' *******************************************************
Private Sub cmdNewCatItem_Click()
   Dim p_strRTF                        As String
   Dim p_strOldRTF                     As String
   Dim p_strCombinedRTF                As String
   Dim p_lngPos                        As Long
   
   ' ------------------------------------------
   ' Don't allow adding a category file to
   '     a message header
   ' ------------------------------------------
   If m_enmFileType <> enmTypeFile.CategoryFile Then
      MsgBox "You cannot add a category item to a Message file."
      Exit Sub
   End If
   
   ' ------------------------------------------
   ' Get current text from RichTextBox
   ' ------------------------------------------
   p_strOldRTF = Me.RichTextBox.TextRTF
   
   ' ------------------------------------------
   ' Remove last '}'
   ' ------------------------------------------
   p_lngPos = InStrRev(p_strOldRTF, "}", -1, vbTextCompare)
   If p_lngPos > 0 Then
      p_strOldRTF = Mid$(p_strOldRTF, 1, p_lngPos - 1) & Mid$(p_strOldRTF, p_lngPos + 1)
   End If
   
   ' ------------------------------------------
   ' Clear the RichTextBox
   ' ------------------------------------------
   Me.RichTextBox.Text = vbNullString
   Me.RichTextBox.TextRTF = vbNullString
   
   ' ------------------------------------------
   ' Set the item text
   ' ------------------------------------------
   p_strRTF = "\par \cf3\b\i " & vbCrLf & _
              "MessageId=0x" & Hex$(m_lngMsgNum) & "\par" & vbCrLf & _
              "Language=English\par" & vbCrLf & _
              "Category " & CStr(m_lngMsgNum) & "\par" & vbCrLf & _
              ".\par" & vbCrLf & _
              "\cf2\i0\f1" & vbCrLf & _
              "}"

   ' ------------------------------------------
   ' Combine the text, and add to RichTextBox
   ' ------------------------------------------
   p_strCombinedRTF = p_strOldRTF & vbCrLf & p_strRTF
   Me.RichTextBox.TextRTF = p_strCombinedRTF
   Me.RichTextBox.Refresh
   Me.RichTextBox.SetFocus
   Me.RichTextBox.SelStart = Len(Me.RichTextBox.TextRTF)
   
   ' ------------------------------------------
   ' Increment the message number
   ' ------------------------------------------
   m_lngMsgNum = m_lngMsgNum + 1
   m_blnTextChanged = True

End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub cmdNewMessage_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:33:36
' Inputs       : N/A
' Outputs      : N/A
' Description  : Clear the textbox and add a header
'              :     for a new message file
' Called By    : *****
' *******************************************************
Private Sub cmdNewMessage_Click()
   Dim p_strRTF                        As String
   
   ' ------------------------------------------
   ' Check to see if current file needs to be saved
   ' ------------------------------------------
   CheckForSave
   
   ' ------------------------------------------
   ' Reset the numbering and the file type
   ' ------------------------------------------
   m_lngMsgNum = 1
   m_enmFileType = enmTypeFile.MsgFile
   m_blnTextChanged = False
   Me.cmdNewMsgItem.Enabled = True
   Me.cmdNewCatItem.Enabled = False
   
   ' ------------------------------------------
   ' Clear the text
   ' ------------------------------------------
   Me.RichTextBox.Text = vbNullString
   Me.RichTextBox.TextRTF = vbNullString
   
   ' ------------------------------------------
   ' Set the initial RTF text
   ' ------------------------------------------
   p_strRTF = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fswiss\fprq2\fcharset0 Arial;}}" & vbCrLf & _
              "{\colortbl ;\red255\green0\blue0;\red0\green0\blue0;\red0\green0\blue255;}" & vbCrLf & _
              "\viewkind4\uc1\pard\cf1\b\f0\fs20 MessageIdTypedef=DWORD\par" & vbCrLf & _
              "\par" & vbCrLf & _
              "LanguageNames=(\par" & vbCrLf & _
              "   English=0x409:MSG00409\par" & vbCrLf & _
              "   )\par" & vbCrLf & _
              "\par" & vbCrLf & _
              "SeverityNames=(Success=0x0:STATUS_SEVERITY_SUCCESS\par" & vbCrLf & _
              "               Informational=0x1:STATUS_SEVERITY_INFORMATIONAL\par" & vbCrLf & _
              "               Warning=0x2:STATUS_SEVERITY_WARNING\par" & vbCrLf & _
              "               Error=0x3:STATUS_SEVERITY_ERROR\par" & vbCrLf & _
              "              )\par" & vbCrLf & _
              "\par" & vbCrLf & _
              "FacilityNames=(\par" & vbCrLf & _
              "   System=0x0FF\par" & vbCrLf & _
              "   Application=0x0\par" & vbCrLf & _
              "   )\par" & vbCrLf & _
              "\cf3\b0\f1\par" & vbCrLf & _
              "}"
   
   ' ------------------------------------------
   ' Add to RichTextBox, and set cursor at
   '     the end of the text
   ' ------------------------------------------
   Me.RichTextBox.TextRTF = p_strRTF
   Me.RichTextBox.SetFocus
   Me.RichTextBox.SelStart = Len(Me.RichTextBox.TextRTF)
   m_blnTextChanged = True

End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub cmdNewMsgItem_Click
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:34:56
' Inputs       : N/A
' Outputs      : N/A
' Description  : Add a new message item to the message
'              :     header
' Called By    : *****
' *******************************************************
Private Sub cmdNewMsgItem_Click()
   Dim p_strRTF                        As String
   Dim p_strOldRTF                     As String
   Dim p_strCombinedRTF                As String
   Dim p_lngPos                        As Long
   
   ' ------------------------------------------
   ' Don't allow adding a category file to
   '     a message header
   ' ------------------------------------------
   If m_enmFileType <> enmTypeFile.MsgFile Then
      MsgBox "You cannot add a message item to a Category file."
      Exit Sub
   End If
   
   ' ------------------------------------------
   ' Select the severity
   ' ------------------------------------------
   frmErrSeverity.Show Modal:=vbModal, _
                       OwnerForm:=Me
   
   ' ------------------------------------------
   ' Get current text from RichTextBox
   ' ------------------------------------------
   p_strOldRTF = Me.RichTextBox.TextRTF
   
   ' ------------------------------------------
   ' Remove last '}'
   ' ------------------------------------------
   p_lngPos = InStrRev(p_strOldRTF, "}", -1, vbTextCompare)
   If p_lngPos > 0 Then
      p_strOldRTF = Mid$(p_strOldRTF, 1, p_lngPos - 1) & Mid$(p_strOldRTF, p_lngPos + 1)
   End If
   
   ' ------------------------------------------
   ' Clear the RichTextBox
   ' ------------------------------------------
   Me.RichTextBox.Text = vbNullString
   Me.RichTextBox.TextRTF = vbNullString
   
   ' ------------------------------------------
   ' Set the item text
   ' ------------------------------------------
   p_strRTF = "\par \cf3\b\i " & vbCrLf & _
              "MessageId=0x" & Hex$(m_lngMsgNum) & "\par" & vbCrLf & _
              "Severity=" & m_strErrSeverity & "\par" & vbCrLf & _
              "Facility=Application\par" & vbCrLf & _
              "SymbolicName=MSG_" & Format$(m_lngMsgNum, "000") & "\par" & vbCrLf & _
              "Language=English\par" & vbCrLf & _
              "%1\par" & vbCrLf & _
              ".\par" & vbCrLf & _
              "\cf2\i0\f1" & vbCrLf & _
              "}"

   ' ------------------------------------------
   ' Combine the text, and add to RichTextBox
   ' ------------------------------------------
   p_strCombinedRTF = p_strOldRTF & vbCrLf & p_strRTF
   Me.RichTextBox.TextRTF = p_strCombinedRTF
   Me.RichTextBox.Refresh
   Me.RichTextBox.SetFocus
   Me.RichTextBox.SelStart = Len(Me.RichTextBox.TextRTF)
   
   ' ------------------------------------------
   ' Increment the message number
   ' ------------------------------------------
   m_lngMsgNum = m_lngMsgNum + 1
   m_blnTextChanged = True

End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub SaveFile
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:35:55
' Inputs       : N/A
' Outputs      : N/A
' Description  : Save the *.MC file, the compile *.BAT
'              :     file, and a text file to import
'              :     into VB
' Called By    : CheckForSave
'              : cmdSave_Click
' *******************************************************
Private Sub SaveFile()
   Dim p_lngFileNum                    As Long
   Dim p_strFilePath                   As String
   Dim p_strJustPath                   As String
   Dim p_strBatName                    As String
   Dim p_strDatName                    As String
   Dim p_strCurrPath                   As String
   
   ' ------------------------------------------
   ' Setup and call the common dialog -- this
   '     gets us the path and filename for the
   '     *.MC file
   ' ------------------------------------------
   Me.CommonDialog1.Flags = cdlOFNCreatePrompt + cdlOFNExplorer + _
                            cdlOFNLongNames + cdlOFNHideReadOnly + _
                            cdlOFNPathMustExist + cdlOFNOverwritePrompt
                            
   Me.CommonDialog1.CancelError = True
   Me.CommonDialog1.DefaultExt = "MC"
   Me.CommonDialog1.DialogTitle = "Save MC File"
   Me.CommonDialog1.Filter = "Message Compiler File (*.MC)"
         
   ' ------------------------------------------
   ' Default to saving one directory up from
   '     the current directory.
   ' ------------------------------------------
   p_strCurrPath = App.Path
   p_strCurrPath = Mid$(p_strCurrPath, 1, _
                        InStrRev(p_strCurrPath, "\", -1) - 1)
   Me.CommonDialog1.InitDir = p_strCurrPath
   
   ' ------------------------------------------
   ' Set the default filename based on the
   '     type of *.MC file we are creating
   ' ------------------------------------------
   If m_enmFileType = MsgFile Then
      Me.CommonDialog1.FileName = "EventMsgs.MC"
   Else
      Me.CommonDialog1.FileName = "Category.mc"
   End If
   
On Error Resume Next
   ' ------------------------------------------
   ' Call the common dialog
   ' ------------------------------------------
   Err.Clear
   Me.CommonDialog1.ShowSave
   
   If Err.Number = cdlCancel Then
      ' ---------------------------------------
      ' User Canceled -- don't do anything
      ' ---------------------------------------
   
   ElseIf Err.Number <> 0 Then
      ' ---------------------------------------
      ' Normal error
      ' ---------------------------------------
      MsgBox "Error in CheckForSave, " & _
             Err.Number & vbCrLf & Err.Description
   Else
      ' ---------------------------------------
      ' Save the file
      ' ---------------------------------------
      Err.Clear
      p_strFilePath = Me.CommonDialog1.FileName
      p_lngFileNum = FreeFile()
      Open p_strFilePath For Output As #p_lngFileNum
      Print #p_lngFileNum, Me.RichTextBox.Text
      Close #p_lngFileNum
      
      ' ---------------------------------------
      ' Get the path without the filename
      ' ---------------------------------------
      p_strJustPath = Mid$(p_strFilePath, 1, InStrRev(p_strFilePath, "\") - 1)
      
      ' ---------------------------------------
      ' Save the BAT file to compile with
      ' ---------------------------------------
      If m_enmFileType = MsgFile Then
         p_strBatName = p_strJustPath & "\Make_Msg.bat"
      Else
        p_strBatName = p_strJustPath & "\Make_Cat.bat"
      End If
      
      SaveBatFile p_strBatName
   
      If Err.Number = 0 Then
         MsgBox "Saved: " & Me.CommonDialog1.FileTitle & vbCrLf & _
                "Batch File: " & p_strBatName
      Else
         MsgBox "Error saving file, " & Me.CommonDialog1.FileName & vbCrLf & _
                Err.Number & ", " & Err.Description
      End If
   
      ' ---------------------------------------
      ' Save the dat file for import into VB
      ' ---------------------------------------
      If m_enmFileType = MsgFile Then
         p_strDatName = p_strJustPath & "\MsgData.txt"
      Else
         p_strDatName = p_strJustPath & "\CatData.txt"
      End If
      
      SaveDatFile p_strDatName
      
      ' Ignore the error -- not critical
   End If
         
   m_blnTextChanged = False

End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub SaveBatFile
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:44:35
' Inputs       : ByVal xi_strBatName:String -
' Outputs      : N/A
' Description  : Write the *.BAT file to compile the
'              :     associated *.MC file
' Called By    : SaveFile()
' *******************************************************
Private Sub SaveBatFile(ByVal xi_strBatName As String)
   Dim p_lngFileNum                    As Long

     p_lngFileNum = FreeFile()
     
     If m_enmFileType = MsgFile Then
        Open xi_strBatName For Output As #p_lngFileNum
        
        Print #p_lngFileNum, "MC -c EventMsgs.mc"
        Print #p_lngFileNum, "RC -r EventMsgs.RC"
        Print #p_lngFileNum, "LINK /nologo /NOENTRY /subsystem:windows /dll /machine:I386 /out:" & Chr$(34) & "EventMsgs.dll" & Chr$(34) & " EventMsgs.res"
        
     Else
        Open xi_strBatName For Output As #p_lngFileNum
        Print #p_lngFileNum, "MC Category.MC"
        Print #p_lngFileNum, "RC -r Category.RC"
        Print #p_lngFileNum, "LINK /nologo /NOENTRY /subsystem:windows /dll /machine:I386 /out:" & Chr$(34) & "Category.dll" & Chr$(34) & " Category.res"

     End If
     
     Close #p_lngFileNum

End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub SaveDatFile
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:46:21
' Inputs       : ByVal xi_strDatName:String -
' Outputs      : N/A
' Description  : Save the data file for import into
'              :     VB if desired
' Called By    : SaveFile()
' *******************************************************
Private Sub SaveDatFile(ByVal xi_strDatName As String)
   Dim p_lngFileNum                    As Long
   Dim p_lngPos                        As Long
   Dim p_lngPos2                       As Long
   Dim p_lngPos3                       As Long
   Dim p_strText                       As String
   Dim p_strTmp                        As String

   ' ---------------------------------------
   ' Save the core data for import into VB
   ' (user may have changed the automatic entries)
   ' ---------------------------------------
   p_strText = Me.RichTextBox.Text
   p_lngPos = 0
   
   If m_enmFileType = MsgFile Then
      p_strTmp = "' Message ID's from " & _
                 Me.CommonDialog1.FileTitle & vbCrLf
   Else
      p_strTmp = "' Category ID's from " & _
                 Me.CommonDialog1.FileTitle & vbCrLf
   End If
   
   Do
      If m_enmFileType = MsgFile Then
         p_lngPos = InStr(p_lngPos + 1, p_strText, "MessageId=")
         If p_lngPos > 0 Then
            p_lngPos2 = InStr(p_lngPos, p_strText, "x")
            p_lngPos3 = InStr(p_lngPos, p_strText, vbCrLf)
            p_strTmp = p_strTmp & "' " & _
                       Mid$(p_strText, (p_lngPos2 + 1), _
                            (p_lngPos3 - p_lngPos2 - 1))
            
            p_lngPos2 = InStr(p_lngPos3, p_strText, "=")
            p_lngPos3 = InStr(p_lngPos2, p_strText, vbCrLf)
            p_strTmp = p_strTmp & ", " & _
                       Mid$(p_strText, (p_lngPos2 + 1), _
                            (p_lngPos3 - p_lngPos2 - 1))
            
            p_lngPos2 = InStr(p_lngPos3, p_strText, "=")
            p_lngPos3 = InStr(p_lngPos2, p_strText, vbCrLf)
            p_strTmp = p_strTmp & ", " & _
                       Mid$(p_strText, (p_lngPos2 + 1), _
                            (p_lngPos3 - p_lngPos2 - 1)) & _
                       vbCrLf
         End If
      
      Else
         p_lngPos = InStr(p_lngPos + 1, p_strText, "MessageId=")
         If p_lngPos > 0 Then
            p_lngPos2 = InStr(p_lngPos, p_strText, "x")
            p_lngPos3 = InStr(p_lngPos, p_strText, vbCrLf)
            p_strTmp = p_strTmp & "' " & _
                       Mid$(p_strText, (p_lngPos2 + 1), _
                            (p_lngPos3 - p_lngPos2 - 1))
            
            p_lngPos2 = InStr(p_lngPos3, p_strText, vbCrLf)
            p_lngPos2 = InStr(p_lngPos2 + 1, p_strText, vbCrLf)
            p_lngPos3 = InStr(p_lngPos2 + 1, p_strText, vbCrLf)
            p_strTmp = p_strTmp & ", " & _
                       Mid$(p_strText, (p_lngPos2 + 2), _
                            (p_lngPos3 - p_lngPos2 - 1)) & _
                       vbCrLf
            
         End If
         
      End If
      
   Loop While p_lngPos > 0
   
   ' ---------------------------------------
   ' Save the data file
   ' ---------------------------------------
   Err.Clear
   p_lngFileNum = FreeFile()
   
   Open xi_strDatName For Output As #p_lngFileNum
   Print #p_lngFileNum, p_strTmp
   Close #p_lngFileNum
   
End Sub

' *******************************************************
' Routine Name : (PRIVATE in FORM) Sub CheckForSave
' Written By   : L.J. Johnson
' Programmer   : L.J. Johnson [Slightly Tilted Software]
' Date Writen  : 05/05/2001 -- 12:53:36
' Inputs       : N/A
' Outputs      : N/A
' Description  : See if user wants to save the file in
'              :     it's current state
'              : DO NOT save the file if no changes have
'              :     been made (don't ask)
' Called By    : cmdNewCategory_Click
'              : cmdNewMessage_Click
' *******************************************************
Private Sub CheckForSave()
   
   If m_blnTextChanged = True Then
      If MsgBox(Prompt:="Do you want to save the current file?", _
                Buttons:=vbQuestion + vbYesNo + vbDefaultButton1, _
                Title:="Save File") = vbYes Then
         SaveFile
      Else
         ' Don't save the file
      End If
                 
      m_blnTextChanged = False

   Else
      ' Nothing to do -- no changes to file
   End If
   
End Sub
